﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Workshop10
{
    interface IBinaryTree<DATA, NODE> where NODE : IBinaryNode<DATA>, new()
    {

        NODE Add(DATA data);

        NODE GetRoot();        
    }

    interface IBinaryNode<DATA> {

        DATA GetData();

        void SetData(DATA data);

        IBinaryNode<DATA> GetLeft();
        IBinaryNode<DATA> GetRight();

        void SetLeft(IBinaryNode<DATA> left);
        void SetRight(IBinaryNode<DATA> right);
    }

    class BinaryNodeInt : IBinaryNode<int>
    {

        int number;

        IBinaryNode<int> left;
        IBinaryNode<int> right;

        public BinaryNodeInt()
        {
        }
       
        public int GetData() {
            return number;
        }

        public void SetData(int data)
        {
            this.number = data;
        }

        public IBinaryNode<int> GetLeft()
        {
            return left;
        }

        public IBinaryNode<int> GetRight()
        {
            return right;
        }

        public void SetLeft(IBinaryNode<int> left)
        {
            this.left = left;
        }

        public void SetRight(IBinaryNode<int> right)
        {
            this.right = right;
        }

    }

    class BinarySearchTree<NODE> : IBinaryTree<int, NODE> where NODE : BinaryNodeInt, new()
    {
        private NODE root;

        public BinarySearchTree()
        {
            root = default(NODE);
        }

        public BinarySearchTree(NODE root)
        {
            this.root = root;
        }

        public NODE GetRoot()
        {
            return root;
        }

        public NODE Add(int data)
        {
            // CREATE NEW NODE
            NODE result = new NODE();
            result.SetData(data);

            // INSERT AS ROOT?
            if (root == null)
            {
                // YES!
                root = result;
                return result;
            }

            // INSERT INTO EXISTING TREE
            NODE n = root;
            while (true)
            {
                // SHOULD WE GO TO THE LEFT
                if (n.GetData() > data)
                {
                    // YES!

                    // LEFT CHILD EXISTS?
                    if (n.GetLeft() == null)
                    {
                        // NOPE
                        // => insert new node there
                        n.SetLeft(result);
                        return result;
                    }
                    else
                    {
                        // YES
                        // => traverse left
                        n = (NODE)n.GetLeft();
                        continue;
                    }
                }

                // n.GetData() <= data
                // => WE GO RIGHT

                // RIGHT CHILD EXISTS?
                if (n.GetRight() == null)
                {
                    // NOPE
                    // => insert new node there
                    n.SetRight(result);
                    return result;
                }
                else
                {
                    // YES
                    // => traverse right
                    n = (NODE)n.GetRight();
                    continue;
                }


            }

        }

    }

}
